﻿Imports System.Data.SqlClient
Imports System.Data

Partial Class ApplicationDetails
    Inherits System.Web.UI.Page

    Dim HTxTAppPrice As New TextBox
    Dim HTxTAppViews As New TextBox
    Dim HTxTAppDownloadURL As New TextBox
    Dim HTxTAppDownloads As New TextBox

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        If String.IsNullOrEmpty(Request.QueryString("AppID")) Then
            Response.Redirect("Default.aspx")
        End If

        If Session("UserID") Is Nothing Then
            Panel3.Visible = True
            Panel4.Enabled = False
        Else
            Panel4.Enabled = True
            Panel3.Visible = False
        End If

        SqlDataSource3.InsertParameters("AppID").DefaultValue = Request.QueryString("AppID")
        SqlDataSource3.InsertParameters("UserID").DefaultValue = Session("UserID")
        SqlDataSource3.InsertParameters("CommentDate").DefaultValue = DateTime.Now.ToString


        If DataList1.Items.Count = 0 Then
            LbmsgNoComments.Visible = True
        Else
            LbmsgNoComments.Visible = False
        End If


        GetDetails()
    End Sub


    Public Sub GetDetails()
        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then

            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString

            Dim sql As String = "SELECT * FROM TableApps WHERE AppID = @AppID"

            conn.Open()
            Dim dt As DataTable = New DataTable()
            Dim adp As Data.SqlClient.SqlDataAdapter = New Data.SqlClient.SqlDataAdapter(sql, conn)
            adp.SelectCommand.Parameters.AddWithValue("AppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            conn.Close()

            If dt.Rows.Count > 0 Then
                HTxTAppPrice.Text = dt.Rows(0)("AppPrice").ToString()
                HTxTAppViews.Text = dt.Rows(0)("AppViews").ToString()
                HTxTAppDownloadURL.Text = dt.Rows(0)("AppDownloadURL").ToString()
                HTxTAppDownloads.Text = dt.Rows(0)("AppDownloads").ToString()
                LViews.Text = dt.Rows(0)("AppViews").ToString()
                LDownloads.Text = dt.Rows(0)("AppDownloads").ToString()

                If HTxTAppPrice.Text = "Free" Or HTxTAppPrice.Text = "" Then
                    BDownload.Text = "Dwonload Free"
                    Session("DW") = HTxTAppDownloadURL.Text.ToString
                Else
                    BDownload.Text = HTxTAppPrice.Text.ToString
                    Session("DW") = "PaymentPage.aspx"
                End If



                GetRating()
                GetComments()

            Else
                Me.Title = "Error..!"
            End If
        Else
            Me.Title = "Error..!"
        End If
    End Sub


    Private Sub RatingNow()
        Try

            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString

            conn.Open()
            Dim sql As String = "INSERT INTO TableRating (RatingAppID, RatingUserID, RatingUsApID, RatingValue) VALUES(@RatingAppID, @RatingUserID, @RatingUsApID, @RatingValue) SELECT @@IDENTITY"
            Dim cmd As SqlCommand = New SqlCommand(sql, conn)

          
            cmd.Parameters.AddWithValue("@RatingAppID", Request.QueryString("AppID"))
            cmd.Parameters.AddWithValue("@RatingUserID", Session("UserID"))
            cmd.Parameters.AddWithValue("@RatingUsApID", Session("UserID") + Request.QueryString("AppID"))
            cmd.Parameters.AddWithValue("@RatingValue", Session("Rx"))

            cmd.ExecuteScalar()
            conn.Close()


            GetRatingValu()
        Catch ex As Exception
            LbR.Text = "you can't repeat rating"
            LbR.ForeColor = Drawing.Color.Red

        End Try

    End Sub


    Public Sub UpdateCounter()
        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then


            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString
            Dim sql As String = "Update TableApps set AppViews =@AppViews where AppID=@AppID"
            conn.Open()
            Dim cmd As SqlCommand = New SqlCommand(sql, conn)
            cmd.Parameters.AddWithValue("AppID", Request.QueryString("AppID"))
            cmd.Parameters.AddWithValue("AppViews", Val(HTxTAppViews.Text) + 1)
            cmd.ExecuteScalar()
            conn.Close()
        Else
            Me.Title = "Error..!"
        End If
    End Sub

    Public Sub UpdateDownload()
        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then

            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString
            Dim sql As String = "Update TableApps set AppDownloads =@AppDownloads where AppID=@AppID"
            conn.Open()
            Dim cmd As SqlCommand = New SqlCommand(sql, conn)
            cmd.Parameters.AddWithValue("AppID", Request.QueryString("AppID"))
            cmd.Parameters.AddWithValue("AppDownloads", Val(HTxTAppDownloads.Text) + 1)
            cmd.ExecuteScalar()
            conn.Close()

        Else
            Me.Title = "Error..!"
        End If
    End Sub

    Public Sub GetRating()
        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then

            Dim GV As New GridView

            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString

            Dim sql As String = "SELECT * FROM TableRating WHERE RatingAppID = @RatingAppID"

            conn.Open()
            Dim dt As DataTable = New DataTable()
            Dim adp As Data.SqlClient.SqlDataAdapter = New Data.SqlClient.SqlDataAdapter(sql, conn)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            conn.Close()

            GV.DataSource = dt
            GV.DataBind()

            Dim ToT As Integer = GV.Rows.Count
            LUsersRating.Text = ToT

        Else
            Me.Title = "Error..!"
        End If
    End Sub

    Public Sub GetComments()
        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then

            Dim GV As New GridView

            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString

            Dim sql As String = "SELECT * FROM TableComments WHERE AppID = @AppID"

            conn.Open()
            Dim dt As DataTable = New DataTable()
            Dim adp As Data.SqlClient.SqlDataAdapter = New Data.SqlClient.SqlDataAdapter(sql, conn)
            adp.SelectCommand.Parameters.AddWithValue("AppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            conn.Close()

            GV.DataSource = dt
            GV.DataBind()

            Dim ToT As Integer = GV.Rows.Count
            Lcomments.Text = ToT

        Else
            Me.Title = "Error..!"
        End If
    End Sub


    Protected Sub Page_LoadComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LoadComplete
        UpdateCounter()
        GetRatingValu()
    End Sub



    Public Sub GetRatingValu()

      

        If Not String.IsNullOrEmpty(Request.QueryString("AppID")) Then

            Dim GV As New GridView
            Dim sql As String
            Dim conn As New SqlConnection()
            conn.ConnectionString = ConfigurationManager.ConnectionStrings("ConnSAhmadAdelMousa").ConnectionString
            sql = "SELECT * FROM TableRating WHERE RatingAppID = @RatingAppID AND RatingValue = @RatingValue"

            conn.Open()
            Dim dt As DataTable = New DataTable()
            Dim adp As Data.SqlClient.SqlDataAdapter = New Data.SqlClient.SqlDataAdapter(sql, conn)
            




            adp.SelectCommand.Parameters.AddWithValue("RatingValue", 1)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            GV.DataSource = dt
            GV.DataBind()
            L1.Text = GV.Rows.Count

            adp.SelectCommand.Parameters.Clear()
            dt.Clear()

            adp.SelectCommand.Parameters.AddWithValue("RatingValue", 2)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            GV.DataSource = dt
            GV.DataBind()
            L2.Text = GV.Rows.Count

            adp.SelectCommand.Parameters.Clear()
            dt.Clear()
            adp.SelectCommand.Parameters.AddWithValue("RatingValue", 3)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            GV.DataSource = dt
            GV.DataBind()
            L3.Text = GV.Rows.Count

            adp.SelectCommand.Parameters.Clear()
            dt.Clear()
            adp.SelectCommand.Parameters.AddWithValue("RatingValue", 4)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            GV.DataSource = dt
            GV.DataBind()
            L4.Text = GV.Rows.Count

            adp.SelectCommand.Parameters.Clear()
            dt.Clear()
            adp.SelectCommand.Parameters.AddWithValue("RatingValue", 5)
            adp.SelectCommand.Parameters.AddWithValue("RatingAppID", Request.QueryString("AppID"))
            adp.Fill(dt)
            GV.DataSource = dt
            GV.DataBind()
            L5.Text = GV.Rows.Count

            conn.Close()

        Else
            Me.Title = "Error..!"
        End If
    End Sub

    Protected Sub DetailsView4_ItemInserted(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DetailsViewInsertedEventArgs) Handles DetailsView4.ItemInserted
        LabelComments.ForeColor = Drawing.Color.Blue
        LabelComments.Text = "Thank you"
        DetailsView4.Enabled = False

    End Sub

    
    
    Protected Sub ImageButton1_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton1.Click
        Session("Rx") = "5"
        RatingNow()
    End Sub

    Protected Sub ImageButton2_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton2.Click
        Session("Rx") = "4"
        RatingNow()
    End Sub

    Protected Sub ImageButton3_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton3.Click
        Session("Rx") = "3"
        RatingNow()
    End Sub

    Protected Sub ImageButton5_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton5.Click
        Session("Rx") = "2"
        RatingNow()
    End Sub

    Protected Sub ImageButton4_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton4.Click
        Session("Rx") = "1"
        RatingNow()
    End Sub

    Protected Sub BDownload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BDownload.Click
        UpdateDownload()

        Response.Redirect(Session("DW"))
    End Sub
End Class
